﻿using EonaCat.SecretVault.Models;
using Microsoft.EntityFrameworkCore;

// This file is part of the EonaCat project(s) which is released under the Apache License.
// See the LICENSE file or go to https://EonaCat.com/License for full license details.

namespace EonaCat.SecretVault.Data
{
    public class SecretDbContext : DbContext
    {
        public SecretDbContext(DbContextOptions<SecretDbContext> options) : base(options) { }
        public DbSet<SecretModel> Secrets => Set<SecretModel>();
        public DbSet<AuditLog> AuditLogs => Set<AuditLog>();
        public DbSet<TenantApiKey> ApiKeys => Set<TenantApiKey>();
    }
}
