﻿using System;
using System.Security.Cryptography;
using System.Text;

namespace EonaCat.SecretVault.Services
{
    // This file is part of the EonaCat project(s) which is released under the Apache License.
    // See the LICENSE file or go to https://EonaCat.com/License for full license details.

    public class HmacService
    {
        private readonly byte[] _hmacKey;
        public HmacService()
        {
            _hmacKey = Convert.FromBase64String(Environment.GetEnvironmentVariable("VAULT_HMAC_KEY")!);
        }

        public string ComputeHmac(string input)
        {
            using var hmac = new HMACSHA256(_hmacKey);
            var hash = hmac.ComputeHash(Encoding.UTF8.GetBytes(input));
            return Convert.ToBase64String(hash);
        }
    }
}
